#include "xintc.h"
#include "xparameters.h"
#include "xgpio.h"
#include "mb_interface.h"



#define INTC_BASEADDR 		XPAR_XPS_INTC_0_BASEADDR
#define INTC_DEVICE_ID		XPAR_XPS_INTC_0_DEVICE_ID
#define INTC_DEVICE_INTR_ID	XPAR_INTC_0_GPIO_1_VEC_ID

void SetupInterruptSystem();
void ButtonInterrupt (void * CallbackRef);

XGpio GpioInput;
XGpio led;
XIntc intc;

static XIntc InterruptController;
int main (void)
{
	
	int test;
	
	
	XGpio_Initialize(&GpioInput, XPAR_PUSH_BUTTONS_5BIT_DEVICE_ID);
	XGpio_Initialize(&led, XPAR_LEDS_8BIT_DEVICE_ID);
	XIntc_Initialize(&intc, XPAR_XPS_INTC_0_DEVICE_ID);
	//XGpio_SetDataDirection(&GpioInput, 1, 0xF);
	XGpio_SetDataDirection(&led, 1, 0x0);
	XGpio_InterruptGlobalEnable(&GpioInput);
	XGpio_InterruptEnable(&GpioInput, XGPIO_IR_CH1_MASK);
	
	XIntc_Start(&intc, XIN_REAL_MODE);
	
	//XIntc_RegisterHandler(INTC_BASEADDR,INTC_DEVICE_INTR_ID,(XInterruptHandler)ButtonInterrupt,NULL);
	XIntc_Connect(&intc, XPAR_XPS_INTC_0_PUSH_BUTTONS_5BIT_IP2INTC_IRPT_INTR, (XInterruptHandler)ButtonInterrupt, NULL);
	XIntc_Enable(&intc, XPAR_XPS_INTC_0_PUSH_BUTTONS_5BIT_IP2INTC_IRPT_INTR);
	
	microblaze_enable_interrupts();
	
	//XIntc_Out32(INTC_BASEADDR + XIN_MER_OFFSET, 0x00000003);
	//XIntc_Out32(INTC_BASEADDR + XIN_SIE_OFFSET, XPAR_PUSH_BUTTONS_5BIT_IP2INTC_IRPT_MASK);
	
	XGpio_DiscreteWrite(&led, 1, 0xAAAAAAAA);
	
	while(1)
	{
		test=XGpio_DiscreteRead(&GpioInput, 1);
		XGpio_DiscreteWrite(&led, 1, test);
	}

}

void ButtonInterrupt (void* CallbackRef)
{
	XGpio_InterruptClear(&GpioInput, XGPIO_IR_CH1_MASK);
	XGpio_DiscreteWrite(&led, 1, 0xFFFFFFFF);
}
